// importation des bibliothèques

// variables utilisées pour tous les programmes :
#define BAUD 9600  // vitesse d'échange pour le port série
#define Info "Modèle acquisition"
unsigned long start = 0 ;
unsigned long last = 0 ;
long delai = 1000 ; // Delai en ms entre 2 appels de la fonction job
bool doJob = false ;

// variables spécifiques au système étudié
#define analogPin   A0

// **********************************************

void setup()
{
  Serial.begin(BAUD) ;
}

void loop()
{
  if (Serial.available())
  {
    String message = Serial.readString() ;
    parse(message) ;
  }
  if (doJob && millis() - last > delai)
  {
    job() ;
    last = millis() ;
  }
}

void parse(String msg)
{
  msg.replace("\r", "") ;
  msg.replace("\n", "") ;
  msg.replace(":", "") ;
  char ordre = msg[0];
  msg.replace(String(ordre), "") ;
  int valeur = 0 ;
  if (msg.length() > 0)
    valeur = msg.toInt() ;
  switch (ordre)
  {
    case 'I' :
      Serial.println(Info) ;
      break ;
    case 'G' :
      go() ;
      break ;
    case 'O' :
      job() ;
      break ;
    case 'S' :
      stop() ;
      break ;
    case 'D' :
      delai = valeur ;
      break ;
    default :
      parse(ordre, valeur) ;
      break ;
  }
}
void go()
{
  doJob = true ;
  start = millis() ;
}

void stop()
{
  doJob = false ; // on éteind la LED
}

// traitement spécifique au système étudié

void parse(char ordre, long valeur)
{
  switch (ordre)
  {
    default :
      break ;
  }
}

void job()
{
  int sensorValue = analogRead(analogPin);
  String msg = "DATA" ;
  msg = msg + ":TIME:" + String(millis() - start) ;
  msg = msg + ":A0:" + String(sensorValue) ;
  Serial.println(msg) ;
}
